# Contributing to opentera
This document is based on [this template](https://github.com/auth0/open-source-template/blob/master/GENERAL-CONTRIBUTING.md).

Reading and following these guidelines will help us make the contribution process easy and effective for everyone involved.
It also communicates that you agree to respect the time of the developers managing and developing these open source projects. 
In return, we will reciprocate that respect by addressing your issue, assessing changes, and helping you finalize your pull requests.

## Quick Links
- [Code of Conduct](#code-of-conduct) 
- [Getting Started](#getting-started)
    - [Issues](#issues)
    - [Pull Requests](#pull-requests)

## Code of Conduct
We take our open source community seriously and hold ourselves and other contributors to high standards of communication.
By participating and contributing to this project, you agree to uphold our Code of Conduct.

## Getting Started
Contributions are made to this repo via Issues and Pull Requests (PRs). A few general guidelines that cover both:
- Search for existing Issues and PRs before creating your own.
- 

### Issues
Issues should be used to report problems with the library, request a new feature, or to discuss potential changes before a PR is created.
When you create a new Issue, a template will be loaded that will guide you through collecting and providing the information we need to investigate.

If you find an Issue that addresses the problem you're having, please add your own reproduction information to the existing issue rather than creating a new one.
Adding a reaction can also help be indicating to our maintainers that a particular problem is affecting more than just the reporter.

### Pull Requests

PRs to our libraries are always welcome and can be a quick way to get your fix or improvement slated for the next release. 
In general, PRs should:
- Only fix/add the functionality in question OR address wide-spread whitespace/style issues, not both.
- Add unit or integration tests for fixed or changed functionality (if a test suite already exists).
- Address a single concern in the least number of changed lines as possible.
- Include documentation in the repo or on our docs site.
- Be accompanied by a complete Pull Request template (loaded automatically when a PR is created).

For changes that address core functionality or would require breaking changes (e.g. a major release), it's best to open an Issue to discuss your proposal first. 
This is not required but can save time creating and reviewing changes.

In general, we follow the "fork-and-pull" Git workflow

1. Fork the repository to your own Github account
2. Clone the project to your machine
3. Create a branch locally with a succinct but descriptive name
4. Commit changes to the branch
5. Following any formatting and testing guidelines specific to this repo
6. Push changes to your fork
7. Open a PR in our repository and follow the PR template so that we can efficiently review the changes.

